<template>
  <!--  假负载电路图  -->
  <load-circuit-diagram
    v-if="diagramType === 'load'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :dev-type="devType"
    :load-curr="loadCurr"
    :dis-curr-max="DisCurrMax"
    :update="update"
  ></load-circuit-diagram>
  <!-- 串负极假负载拓扑图 -->
  <load-reverse-circuit-diagram
    v-else-if="diagramType === 'loadReverse'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :dev-type="devType"
    :buscouple-switch="buscoupleSwitch"
  ></load-reverse-circuit-diagram>
  <!-- 交流电网电路图   -->
  <grid-circuit-diagram
    v-else-if="diagramType === 'grid'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :dev-type="devType"
    :buscouple-switch="buscoupleSwitch"
  ></grid-circuit-diagram>
  <collect-circuit-diagram
    v-else-if="diagramType === 'collect'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :hum="hum"
    :temp="temp"
    :update="update"
    :batt="batt"
    :is-show-tool="isCollect"
  ></collect-circuit-diagram>
  <lithium-diagram
    v-else-if="diagramType === 'lithium'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :batt="batt"
  ></lithium-diagram>
  <ld9-diagram
    v-else-if="diagramType === 'ld9'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :charge-mon="chargeMon"
    :discharge-mon="dischargeMon"
    :type="type"
    :update="update"
    :batt="batt"
  ></ld9-diagram>
  <bts9140-diagram
    v-else-if="diagramType === 'bts9140'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :charge-mon="chargeMon"
    :discharge-mon="dischargeMon"
    :type="type"
    :update="update"
    :batt="batt"
  ></bts9140-diagram>
  <lithium-fbo-diagram
    v-else-if="diagramType === 'lithiumFbo'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :mode="mode"
    :update="update"
    :batt="batt"
  ></lithium-fbo-diagram>
  <fbo4831-diagram
    v-else-if="diagramType === 'fbo4831'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :batt="batt"
  ></fbo4831-diagram>
  <normal9150
    v-else-if="diagramType === 'bts9150'"
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :drop-vol="dropVol"
    :contact-res="contactRes"
    :load-curr="loadCurr"
    :bypass="bypass"
    :batt="batt"
    :is-show-tool="isBTS9150"
  ></normal9150>
  <!--  通用电路图  -->
  <normal-circuit-diagram
    v-else
    :online-vol="onlineVol"
    :group-vol="groupVol"
    :batt-curr="battCurr"
    :dev-temp="devTemp"
    :type="type"
    :update="update"
    :drop-vol="dropVol"
    :contact-res="contactRes"
    :load-curr="loadCurr"
    :dis-curr-max="DisCurrMax"
    :start="start"
  ></normal-circuit-diagram>
  <!--    </div>-->
  <!--  </div>-->
</template>

<script>
import LoadCircuitDiagram from "./diagrams/load";
import LoadReverseCircuitDiagram from "./diagrams/loadReverse";
import GridCircuitDiagram from "./diagrams/grid";
import NormalCircuitDiagram from "./diagrams/normal";
import CollectCircuitDiagram from "./diagrams/collect";
import LithiumDiagram from "./diagrams/lithium";
import fbo4831Diagram from "./diagrams/fbo4831";
import LithiumFboDiagram from "./diagrams/lithiumFbo";
import Ld9Diagram from "./diagrams/ld9";
import Bts9140Diagram from "./diagrams/parallelPower";
import normal9150 from "./diagrams/normal9150";
import { regEquipType } from "@/assets/js/tools";
import { const_devType } from "@/assets/js/const";
import getItemByKey from "@/assets/js/tools/getItemByKey";

export default {
  components: {
    LoadCircuitDiagram,
    LoadReverseCircuitDiagram,
    GridCircuitDiagram,
    NormalCircuitDiagram,
    CollectCircuitDiagram,
    LithiumDiagram,
    LithiumFboDiagram,
    Ld9Diagram,
    Bts9140Diagram,
    fbo4831Diagram,
    normal9150,
  },
  props: {
    onlineVol: {
      // 在线电压
      type: [String, Number],
      default: 0,
    },
    groupVol: {
      // 组端电压
      type: [String, Number],
      default: 0,
    },
    battCurr: {
      // 电池电流
      type: [String, Number],
      default: 0,
    },
    devTemp: {
      // 设备温度
      type: [String, Number],
      default: 0,
    },
    type: {
      type: Number,
      default: -1,
    },
    update: {
      type: Boolean,
      default: true,
    },
    version: {
      type: String,
      default: "",
    },
    dropVol: {
      // 导通压降
      type: [String, Number],
      default: 0,
    },
    contactRes: {
      // 接触器阻抗
      type: [String, Number],
      default: 0,
    },
    batt: {
      type: Object,
      default() {
        return {};
      },
    },
    start: {
      type: Array,
      default() {
        return [280, 40];
      },
    },
    devType: {
      type: Number,
      default: 0,
    },
    chargeMon: {
      type: String,
      default: "--------------",
    },
    dischargeMon: {
      type: String,
      default: "--------------",
    },
    buscoupleSwitch: {
      type: Number,
      default: 0,
    },
    // 工作模式 0离线 1在线
    mode: {
      type: Number,
    },
    bypass: {
      // 旁路开关
      type: Object,
      default() {
        return {
          drynodeCommst: 0xaaaa, // 干接点通信状态(0xAAAA-正常  0xBBBB-异常)
          k1CheckSt: 0xaaaa, // 接触器k1检测状态(0xAAAA-正常  0xBBBB-异常)
          k1St: 0, // 接触器k1状态（0-断开  1-闭合）
          urgentswitchSt: 0xaaaa, // 急停状态(0xAAAA-未触发  0xBBBB-触发)
          bypassswitchSt: 0xaaaa, // 旁路状态（0xAAAA-未接入  0xBBBB-接入旁路）
        };
      },
    },
    temp: {
      // 温度
      type: [String, Number],
      default: 0,
    },
    hum: {
      // 湿度
      type: [String, Number],
      default: 0,
    },
    calcLoadCurr: {
      type: [String, Number]
    },
  },
  computed: {
    isCollect() {
      let batt = this.batt;
      return regEquipType(batt.fbsdeviceId, ["BTS9605", "BTS9611"]);
    },
    isBTS9150() {
      let batt = this.batt;
      return regEquipType(batt.fbsdeviceId, "BTS9150");
    },
    diagramType() {
      let rs = "normal";
      let batt = this.batt;
      let devId = batt.fbsdeviceId;
      let pattern61852 = /^61852/;
      // 根据设备的类型获取设备的信息
      if (regEquipType(devId, "BTS9110")) {
        // 假负载
        // let pattern = /^D:6/;
        // if (pattern.test(this.version)) {
        //   rs = "load";
        // } else {
        //   rs = "loadReverse";
        // }
        rs = "load";
      } else if (regEquipType(devId, "BTS9120") || pattern61852.test(devId)) {
        // 交流电网
        rs = "grid";
      } else if (regEquipType(devId, ["BTS9605", "BTS9611", "BTS9612"])) {
        rs = "collect";
      } else if (regEquipType(devId, ["lithium", "lithiumPack", "li9132"])) {
        rs = "lithium";
      } else if (regEquipType(devId, "LD9")) {
        rs = "ld9";
      } else if (regEquipType(devId, ["BTS9140", "BTS9141"])) {
        rs = "bts9140";
      } else if (regEquipType(devId, ["fbo4830", "fbo4815"])) {
        // rs = batt.cellShowType == 1 ? "lithium" : "normal";
        rs = "lithiumFbo";
      } else if (regEquipType(devId, "fbo4831")) {
        rs = "fbo4831";
      } else if (regEquipType(devId, "BTS9150")) {
        rs = "bts9150";
      } else if (regEquipType(devId, "fbo6186")) {
        rs = "load";
      } else if (regEquipType(devId, "fbo6187")) {
        rs = "grid";
      }
      // 根据电池信息配置信息的电路图类型对电路图进行重新定义
      if (batt.topologyMapType) {
        let topologyMapTypeItem = getItemByKey(
          batt.topologyMapType,
          const_devType.pictureTypes
        );
        if (topologyMapTypeItem) {
          rs = topologyMapTypeItem.value;
        }
      }
      return rs;
    },
    loadCurr() {
      return this.calcLoadCurr 
        ? this.calcLoadCurr 
        : this.batt.loadCurr != undefined
        ? this.batt.loadCurr.toHold(2)
        : "??";
    },
    DisCurrMax() {
      return this.batt.disCurrMax != undefined ? this.batt.disCurrMax : "??";
    },
  },
  mounted() {},
};
</script>
